﻿using System;

namespace Library;

public class Book : IComparable<Book>
{
    public Book(string title, decimal price, string author)
    {
        this.Title = title;
        this.Price = price;
        this.Author = author;
    }

    public string Title { get; }

    public decimal Price { get; }

    public string Author { get; }

    public int CompareTo(Book other)
    {
        if (other is null)
        {
            throw new NullReferenceException();
        }

        int compareResult = string.Compare(this.Title, other.Title, StringComparison.InvariantCulture);
        
        if (compareResult == 0)
        {
            compareResult = string.Compare(this.Author, other.Author, StringComparison.InvariantCulture);
        }

        if (compareResult == 0)
        {
            compareResult = this.Price.CompareTo(other.Price);
        }

        return compareResult;
    }

    public override string ToString()
    {
        string result = $"{this.Title}-{this.Author}-{this.Price:F2}";
        return $"{{{result}}}";
    }
}
